/****************************************

        xNes SOURCE CODE

ONLY FOR THE XNES TEAM !

        ***************************************/

//
// Pour l'instant il y a beaucoup de messages pour suivre pas  pas
// qui je pense prenne de la place.
//
// Dans les prochaines versions tous a aura disparu : )
//

// LAST NIGHT A DJ SAVE MY LIFE...:)

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>

#include        <signal.h>

#include        <malloc.h>

#include        <allegro.h>

#include        "M6502\M6502.h"
#include        "xnes.h"
#include        "nes.h"

#define         FatalError( msg )       { printf("%s\n",msg); exit(1); }
#define         Help()                  printf( "Syntax :\n%s <filename.nes> [-flags]\n\n\t\t-f x \t\t: Set frame rate to x (default : 1/3)\n\t\t-iperiod\t: Set IPeriod (default : 8000)\n\t\t-linear\t\t: Enable Linear Frame Buffer\n\t\t-vga\t\t: Use standard VGA mode\n\t\t-b x\t\t: Force to use x as the battery file\n\t\t-modex\t\t: Enable the ModeX mode\n-gfx x\t\t: 1 => use the old Graphic Engine\n\t\t  2 => use the new (default)\n" , argv[0] );

#define         Version         "0.50"         // No de version

int     FirstRead = 1;
int     Joypad_Toggle = 0;
int     Joypad_Read_1 = 1;

//
// Option pour le skip frame
//
int     FrameRate = 3;          // 3 par dfaut
int     CurrentFrame = 1;
int     iperiod = 8000;
int     MMC,MMC_chr,MMC_Bank_Size;
int     MMC_low_base , MMC_high_base;
int     MMC1_Reg_0 = 0 , MMC1_Reg_1 = 0 , MMC1_Reg_2 = 0 , MMC1_Reg_3 = 0;
int     MMC1_Reg_0_WriteNo = 0 , MMC1_Reg_1_WriteNo = 0 , MMC1_Reg_2_WriteNo = 0 , MMC1_Reg_3_WriteNo = 0;
int     MMC_Base_Bootup,MMC_Size_Select;
int     CHR_Ram = 0, PRG_Rom = 0;
int     MMC_mode = NULL;
int     MMC1_High = 0;
int     Toggle_Scroll = 0;
int     MMC4_DOIRQ = 0, MMC4_IRQ = -1, MMC4_mid_base, MMC4_hmid_base;

//
// Ouf on arrive au main :)
//

M6502   *M;

void    Quit_XNes( char * );        
void    Quit_Save_VRam( void );
int     MMC7_Write( byte , word );
int     MMC9_Write( word , byte );

main( int argc , char *argv[] )
{
        FILE    *Nes,*Battery_File;

        char    OptROM[2] , Option[80] , Tmp[80] , Argument[80];
        int     CHR_Ram = 0, PRG_Rom = 0,Cart_Size,Wait = 0,i,Addr,Force_Battery = 0;

        int     sizeCHR = 0 , sizePRG = 0;

        printf( "xNes %s <<>> Nes Emulator\n" , Version );

        puts("(C)1997 HAMEL Nicolas & MICHEL David\n\txNes Team emulator\n" );

        Linear = 0;
        Vga = 0;
        ModeX = 0;

        MMC_low_base = 0;
        MMC_high_base = 0;                
        Trainer = 0;

        Screen_Change = 0;
        Graphic_Engine = 2;

        //      Pointeur
        M = malloc( sizeof( M6502 ) );

        //      Vrifie les arguments et actionne les options
        if( argc == 1 )
                FatalError("Bad Number of arguments ! Type -? for help.");
        
        for( i = 1 ; i < argc ; i++ )
        {
                strcpy( Argument , argv[ i ] );

                if( Argument[ 0 ] == '-' )
                {
                        if( Wait == 0 )
                        {
                        if( strcmp( Argument , "-b" ) == 0 )
                        {
                                strcpy( Battery_Name , argv[ i+1 ] );
                                Wait = 1;
                                printf(" User for to use %s as the battery file.\n",Battery_Name );
                                Force_Battery = 1;
                        }
                        if( strcmp( Argument , "-f" ) == 0 )
                        {
                                FrameRate = atoi(argv[ i+1 ]);
                                printf(" Frame Rate set to 1/%d.\n",FrameRate);
                                Wait = 1;
                        }
                        if( strcmp( Argument , "-?" ) == 0 )
                        {
                                Help();
                                exit(1);
                        }
                        if( strcmp( Argument , "-iperiod" ) == 0 )
                        {
                                iperiod = atoi(argv[ i+1 ]);
                                printf(" IPeriod set to %d.\n",iperiod);
                        }
                        if( strcmp( Argument , "-gfx" ) == 0 )
                        {
                                Graphic_Engine = atoi( argv[ i+1 ] );
                                switch( Graphic_Engine )
                                {
                                        case 1:
                                                puts(" Old graphic engine selected");
                                                break;
                                        case 2:
                                                puts(" New graphic engine selected");
                                                break;
                                        default:
                                                puts("\t Unknow graphic Engine");
                                                break;
                                }
                                Wait = 1;
                        }
                        if( strcmp( Argument , "-modex" ) == 0 )
                        {
                                puts(" ModeX enabled");
                                ModeX = 1;
                        }
                        if( strcmp( Argument , "-linear" ) == 0 )
                        {
                                Linear = 1;
                                puts(" Using Linear frame buffer.");
                        }
                        if( strcmp( Argument , "-vga" ) == 0 )
                        {
                                Vga = 1;
                                puts(" Using VGA...");
                        }
                        }
                        else
                                Wait = 0;
                }
        }

        puts("");

        strcpy( CartName , argv[1] );

        // Vrifie si c'est bien un format iNes

        Nes = fopen( CartName , "rb" );

        if( !Nes )                                                 
        {
                FatalError("File not found!");
        }
        else
        {
                fread( Tmp , 1 , 3 , Nes );
                Tmp[3] = '\0';
                if( strcmp( Tmp , "NES" ) != 0 )
                {
                        fclose(Nes);
                        puts("Unsupported file format.");
                        exit(1);
                }
        }

        puts("iNes file format found.");

        fseek( Nes, 4 , 0 );

        // Prise du nombre de PRG Rom et de CHR Ram

        PRG_Rom = fgetc( Nes );

        CHR_Ram = fgetc( Nes );

        printf("[ %d ] of PRG Rom\n",PRG_Rom);
        printf("[ %d ] of CHR Ram\n",CHR_Ram);

        Cart_Size = (PRG_Rom<<4)+CHR_Ram*8;

        MMC_high_base = ( PRG_Rom-1 ) * 16384;

        printf( "\n\tSize of the Cartridge : [ %d Ko ]\n\n" , Cart_Size );

        // Vrifie si la cartouche est support
        // MMCs 2 en cours........

        fseek( Nes , 6 , 0 );
        i = fgetc( Nes );

        // Prise des options de la ROM

        sprintf( OptROM , "%x", i );

        if( strlen( OptROM ) == 1 )
        {
                OptROM[1] = OptROM[0];
                OptROM[0] = '0';
        }

        if( !OptROM[1] )
                OptROM[1] = '0';


        switch( OptROM[ 0 ] )
        {
                case    '0':
                        puts(" No iNes mapper found.");
                        MMC = 0;
                        break;
                case    '1':
                        puts(" iNes mapper #1 found.");
                	MMC = 1;
                        MMC_low_base = 0;
                        MMC_high_base = ( PRG_Rom - 1 ) * 16384;
                        MMC1_High = MMC_high_base;
                	break;
                case    '2':
                        puts(" iNes mapper #2 found.");
                        MMC = 2;
                        break;
                case	'3':
                        puts(" iNes mapper #3 found.");
                	MMC = 3;
                	break;
                case	'4':
                        puts(" iNes mapper #4 found.");
                	MMC = 4;
                        MMC_low_base = 0;
                	break;
              	case	'7':
                        puts(" iNes mapper #7 found.");
              		MMC = 7;
              		MMC_low_base = 0;
              		break;
                case    '9':
                        puts(" iNes mapper #9 found.");
                        MMC = 9;
                        MMC_low_base = 0;
                        break;
              	case	'b':
                        puts(" iNes mapper #11 found.");
              		MMC = 11;
              		MMC_low_base = 0;
              		break;
              		
                default:
                        fclose( Nes );
                        #ifdef macintosh
                                FlushEvents( everyEvent , 0 );
                                HideWindow( gSIOUXWindow );
                                Alert( 120 , 0L ); //Unsupported MMC

                                return;
                        #else
                                FatalError( " iNes mapper not supported." );
                        #endif
        }
        
        // Ici je check les options de la ROM
        // Vrifie si il a un MMcs si oui >> J'ABANDONNE !!! Okay David ?

        // J'ai chang le OptROM[1] par atoi(OptROM[1])
        // comme a pas de pb avec les a-->f si maj. ou min.:)

        // J'ai aussi vir le dfault...inutile

        switch( atoi(&OptROM[1]) )
        {
                case 0x0:
                        Mirroring = 1; // Horizontal
                        break;
                case 0x1:
                        Mirroring = 2; // Vertical
                        break;
                case 0x2:
                        Mirroring = 1;
                        Battery = 1; // Battery ON !
                        break;
                case 0x3:
                        Mirroring = 2;
                        Battery = 1;
                        break;
                case 0x4:
                        Mirroring = 1;
                        Trainer = 1;
                        break;
                case 0x5:
                        Mirroring = 2;
                        Trainer = 1;
                        break;
                case 0x6:
                        Mirroring = 1;
                        Battery = 1;
                        Trainer = 1;
                        break;
                case 0x7:
                        Mirroring = 2;
                        Battery = 1;
                        Trainer = 1;
                        break;
                case 0x8:
                        Mirroring = 1;
                        SVRam = 1;
                        break;
                case 0x9:
                        Mirroring = 2;
                        SVRam = 1;
                        break;
                case 0xa:
                        Mirroring = 1;
                        Battery = 1;
                        SVRam = 1;
                        break;
                case 0xb:
                        Mirroring = 2;
                        Battery = 1;
                        SVRam = 1;
                        break;
                case 0xc:
                        Mirroring = 1;
                        Trainer = 1;
                        SVRam = 1;
                        break;
                case 0xd:
                        Mirroring = 2;
                        Trainer = 1;
                        SVRam = 1;
                        break;
                case 0xe:
                        Mirroring = 1;
                        Battery = 1;
                        Trainer = 1;
                        SVRam = 1;
                        break;
                case 0xf:
                        Mirroring = 2;
                        Battery = 1;
                        Trainer = 1;
                        SVRam = 1;
                        break;
        }

        switch( Mirroring )
        {
                case 1:
                        puts(" Horizontal Mirroring found.");
                        break;
                case 2:
                        puts(" Vertical Mirroring found.");
                        break;
        }


        // J'ai vir le case 0

        // Allocation de la mmoire

        puts(" Allocating Memory.");

        sizePRG = ( PRG_Rom+1 ) * 16 * 1024;
        sizeCHR = ( CHR_Ram+1 ) * 8 * 1024;

        RAM = (byte *)malloc( 0x10000 );

        ROM = (byte *)malloc( sizePRG );

        VRAM = malloc( 0x4000 );

        VROM = malloc( sizeCHR );

        SRAM = malloc ( 0x0100 );

        if( !RAM || !ROM || !VRAM || !VROM || !SRAM )
                FatalError( " Not enough memory.");

        memset( SRAM , 0 , 0x0100 );
        memset( RAM , 0 , 0x10000 );
        memset( ROM , 0 , sizePRG );
        memset( VRAM , 0 , 0x4000 );
        memset( VROM , 0 , sizeCHR );

        puts(" All memory allocated");

        printf("\n Loading ROM...");

        // Tous ca est fait si aucun MMC

        if( MMC == 0 )
        {
        // Copie des PRG et des CHR en RAM et en VRAM
        
        fseek( Nes , 16 , 0 );

        // L il charge le trainer
        // Je sais pas bien  quoi a sert mais je l'ai quand mme copi
        // comme il dise

        if( Trainer == 1 )
        {
                //                        
                // J'ai mais partially suported parceque je sais pas
                //  quoi ca sert
                //                        
                printf("Trainer found...");
                fseek( Nes , 16 , 0 );
                
                // Je lis les 512 bytes de trainer
                fread( &RAM[0x7000] , 1 , 512 , Nes );
        }

        // J'ai chang un if par un switch 
        switch( PRG_Rom )
        {
                case 1:
                {                        
                        // J'avais oubli quelque chose !! le fseek !
                        if( Trainer == 0 )
                                fseek( Nes , 16 , 0 );
                        printf("Only 1 Prg ROM found...");

                        fread( &ROM[0x4000] , 1 , 0x4000 , Nes );
                        break;
                }
                case 2:
                {
                        // Idem ii
                        if( Trainer == 0 )
                                fseek( Nes , 16 , 0);
                        printf("Two Prg ROM found...");
                        fread( ROM , 1 , 0x8000 , Nes );
                        break;
                }
        }

        if( CHR_Ram > 2 )
                FatalError( "Too many CHR Ram !" );

        fread( VRAM , 1 , 0x2000 , Nes );
        
        puts("Ok.");

        }
        if( Battery == 1 )
        {
                puts("\n A backed memory has been found.");

                // Chargement de la Backed Memory
                if( Force_Battery == 0 )
                {
                        strcpy( Battery_Name , CartName );
                        sprintf( &Battery_Name[ strlen( CartName )-4 ] , ".sav" );
                }

                printf(" Loading %s...",Battery_Name);

                Battery_File = fopen( Battery_Name , "rb" );

                if( !Battery_File )
                {
                        puts("Failed!\nCannot find the battery. Seems to be the first use of game.");
                }
                else                        
                {
                        fread( &RAM[ 0x6000 ] , 1 , 0x2000 , Battery_File );
                        puts("Ok.");
                        fclose( Battery_File );
                }

        }                

        //
        // Chargement de la ROM si MMC
        //
        if( MMC != 0 )
        {
                switch( MMC )
                {
                	case 1:
	             		fseek( Nes , 16 , 0);
				fread(  ROM , 1 , 0x4000*PRG_Rom , Nes );
               			fread( VROM , 1 , 0x2000*CHR_Ram , Nes );
				break;
                        case 2:
                                fseek( Nes , 16 , 0);
                                fread( ROM , 1 , 0x4000*PRG_Rom , Nes );
                                break;
                        case 3:
                        	fseek( Nes , 16 , 0);
                                fread(  ROM , 1 , 0x4000*PRG_Rom , Nes );
                                if( CHR_Ram > 0 )
                                {
                                        fread( VROM , 1 , 0x8000 , Nes );
                                        memcpy( VRAM , VROM , 0x2000 );
                                }
                        	break;
			case 4:
                                fseek( Nes , 16 , 0 );
                                fread( ROM , 1 , 0x4000*PRG_Rom , Nes );
                                fread( VROM , 1 , 0x2000*CHR_Ram , Nes );
                                MMC4_mid_base = MMC_low_base;
                                MMC4_hmid_base = MMC_high_base;
                                break;
                        case 7:
                        	fseek( Nes , 16 , 0);
                                fread( ROM , 1 , 0x4000*PRG_Rom , Nes );
                        	break;
                        case 9:
                                fseek( Nes , 16 , 0 );
                                fread( ROM , 1 , 0x4000*PRG_Rom , Nes );
                                fread( VROM , 1 , 0x2000*CHR_Ram , Nes );
                                printf("...MMC 9 has %d x 8Ko.\n",PRG_Rom*2 );

                                MMC_high_base = (( PRG_Rom*2 )-3)*8192;  // *2 To get the number of 8 KO pages
                                                                         // -3 to get the last three 8 ko pages
                                                                         // *8192 for the 8 Ko page

                                // Copying the last Three page of 8 ko into the RAM !
                                memcpy( &RAM[ 0xA000 ] , &ROM[ MMC_high_base ] , 0x6000 );

                                // Copying the first 8 ko page into 0x8000
                                memcpy( &RAM[ 0x8000 ] , &ROM[ 0x0 ] , 0x2000 );

                                break;
                        case 11:
                        	fseek( Nes , 16 , 0);
                                fread( ROM , 1 , 0x4000*PRG_Rom , Nes );
                                fread( VROM , 1 , 0x2000*CHR_Ram , Nes );
                        	break;
                }
        }

        puts("\nPress a key to launch the emulation...");
        getch();
        fflush(stdin);

        // Initialisation de la machine
        InitMachine();
        
        // Initialisation du IPeriod
        M->IPeriod = iperiod;
        PPU_addr_toggle = 0;
	PPU_REG_5A = 0;
	PPU_REG_5B = 0;
        BGScroll_toggle = 0;
        Joypad_1 = 0;
        Joypad_Read_1 = 0;
        
        // Lancement du 6502
        Reset6502(M);
        Run6502(M);

        // On foue  la poubelle !
        TrashMachine();

        // Fin du programme :)
end:
        puts("\n  Thanks for using xNes!");

        free(RAM);
        free(ROM);
        free(VRAM);
        free(SRAM);
        fclose(Nes);
        free(M);
}

int    CheckKb( void )
{
        if( key[ KEY_UP ] )
        {
                WriteBit( Joypad_1 , 1 , 4 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 4 );
        }

        if( key[ KEY_ENTER ] )
        {
                WriteBit( Joypad_1 , 1 , 3 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 3 );
        }

        if( key[ KEY_ALT ] )
        {
                WriteBit( Joypad_1 , 1 , 0 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 0 );
        }

        if( key[ KEY_CONTROL ] )
        {
                WriteBit( Joypad_1 , 1 , 1 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 1 );
        }
        if( key[ KEY_TAB ] )
        {
                WriteBit( Joypad_1 , 1 , 2 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 2 );
        }
        if( key[ KEY_DOWN ] )
        {
                WriteBit( Joypad_1 , 1 , 5 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 5 );
        }
        if( key[ KEY_LEFT ] )
        {
                WriteBit( Joypad_1 , 1 , 6 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 6 );
        }
        if( key[ KEY_RIGHT ] )
        {
                WriteBit( Joypad_1 , 1 , 7 );
        }
        else
        {
                WriteBit( Joypad_1 , 0 , 7 );
        }
        if( key[ KEY_ESC ] )
                        Quit();
        if( key[ KEY_F12 ] )
                        SnapScreen();
        if( key[ KEY_F1 ] )
                Swap_To_Gui();
        if( key[ KEY_F5 ] )
        {
                // Initialisation du IPeriod
                M->IPeriod = iperiod;
                PPU_addr_toggle = 0;
                PPU_REG_5A = 0;
                PPU_REG_5B = 0;
                BGScroll_toggle = 0;
                Joypad_1 = 0;
                Joypad_Read_1 = 0;
        
                // Lancement du 6502
                Reset6502(M);
                Run6502(M);
        }                
        if( key[ KEY_PLUS_PAD ] )
                        FrameRate++;
        if( key[ KEY_MINUS_PAD ] )
        {
                        FrameRate--;
                        if( FrameRate < 1 )
                                FrameRate = 1;
        }                
}

int     Reset_Nes()
{
        // Initialisation du IPeriod
        M->IPeriod = iperiod;
        PPU_addr_toggle = 0;
	PPU_REG_5A = 0;
	PPU_REG_5B = 0;
        BGScroll_toggle = 0;
        Joypad_1 = 0;
        Joypad_Read_1 = 0;
        
        // Lancement du 6502
        Reset6502(M);
}

int     Quit()
{
        FILE *Battery_File;

                        TrashMachine();
                        if( Battery == 1 )
                        {
                                printf("Saving the backed battery [ %s ]...",Battery_Name);

                                Battery_File = fopen( Battery_Name , "wb" );
                                if( !Battery_File )
                                {
                                        puts("Failed!");
                                        puts("Cannot open the file.");
                                }
                                else
                                {
                                        fwrite( &RAM[ 0x6000 ] , 1 , 0x2000 , Battery_File  );
                                        puts("Ok.");
                                }
                        }
                        FatalError("Thanks for using xNes.");
}

void Write_PPU (byte Value)
{
        int     i;

	// Do a sanity check on the range
	PPU_REG_6 &= 0x3fff;
					
	VRAM [PPU_REG_6] = Value;

	// Handle mirrored PPU VRAM writes
	if (PPU_REG_6 & 0x2000)
	{
		if (Mirroring == 2) /* Vertical */
		{
			if (PPU_REG_6 & 0x800)
				VRAM [PPU_REG_6 - 0x800] = Value;
			else
				VRAM [PPU_REG_6 + 0x800] = Value;
		}
		else if (Mirroring == 1) /* Horizontal */
		{
			if (PPU_REG_6 & 0x400)
				VRAM [PPU_REG_6 - 0x400] = Value;
			else
				VRAM [PPU_REG_6 + 0x400] = Value;
		}
	}

	// Handle mirrored PPU palette writes
	if (PPU_REG_6 == 0x3f10)
	{
                for( i = 0x3F00 ; i <= 0x3F1C ; i += 0x04 )
                        VRAM[ i ] = Value;
	}

	if (RAM[0x2000] & 0x04)
		PPU_REG_6 += 32;
	else
                PPU_REG_6++;
}

// **********************************************************************
// *                                                                    *
// *                  FONCTION SPECIFIQUE  XNES                        *
// *                                                                    *
// **********************************************************************

// Cela n'aurait pu tre accompli si David ne m'aurait aider
// Encore un greeting ! 

inline byte Rd6502(register word addr)
{
        byte    retour;
        int     key;

        // Un,dos,tres , yarrive  compter sur mes doigts.

        switch (addr & 0xE000)
        {
        case 0x0000:
        {
                // Access RAM standard
                return( RAM[ addr&0x07FF ] );
        }
        case 0x2000:
        {
            switch (addr)
            {
            case 0x2002:
            {
                // 0x2002 : PPU Status Register
                // Standard
        
                retour = RAM[ addr ];

                RAM[ 0x2002 ] &= 0x3F;

                return( retour );
            }
            case 0x2004:
            {
                // SPRITE MEMORY DATA
                // Ecriture et Lecture
                return( RAM[0x2003] );
            }
            case 0x2006:
            {
                // PPU Memory Adress
                // THIS NIGHT A DAVID SAVE MY LIFE ....:))

                return( PPU_REG_6 );
            }                
            case 0x2007:
            {
                // PPU IO Register

                // Lit ou Ecrit la VRAM  l'adresse spcifi en 0x2006


                retour = VRAM[ PPU_REG_6 ];

                if( FirstRead > 1 )
                {
                        if( ReadBit( RAM[ 0x2000 ] , 2 ) == 1 )
        	              PPU_REG_6 += 32;
                	else
	                      PPU_REG_6 += 1;
        	        break;
                }

                return( retour );
            }
            default:
                return( RAM[ addr ] );
            }

        }
        case 0x4000:
        switch(addr)
        {
                case 0x4016:
                {
                        RAM[0x4016] = ReadBit( Joypad_1, Joypad_Read_1);

                        Joypad_Read_1 = (Joypad_Read_1 + 1) & 0x7;

                        return (RAM[0x4016]);
                }
                // A ecrire
                default:
                                return( RAM[addr] );
        }

        case 0x6000:
                return( RAM[addr] );
	default:
	{
		// Reading ROM
		
		// Switch MMC
		switch( MMC )
		{
			case 0:
				// Aucun MMC
				return( ROM[ addr - 0x8000 ] );
				break;
			case 1:
				switch( addr & 0xE000 )
				{
					case 0x8000:
					case 0xA000:
                                                return( ROM[ MMC_low_base + (addr & 0x3FFF) ] );
					case 0xC000:
					case 0xE000:
						return( ROM[ MMC_high_base + (addr & 0x3FFF) ] );
				}
                                break;
                        case 2:
				switch( addr & 0xE000 )
				{
					case 0x8000:
					case 0xA000:
						return( ROM[ MMC_low_base + (addr & 0x3FFF) ] );
					case 0xC000:
                                        case 0xE000:
                                                return( ROM[ MMC_high_base + (addr & 0x3FFF ) ] );
				}
                                break;
			case 3:
				return( ROM[ addr - 0x8000 ] );
				break;
                        case 4:
                                switch( addr & 0xE000 )
                                {
                                        case 0x8000:
                                                return( ROM[ MMC_low_base + (addr & 0x3FFF)] );
                                        case 0xA000:
                                                return( ROM[ MMC4_mid_base + (addr & 0x3FFF)] );
                                        case 0xC000:
                                                return( ROM[ MMC4_hmid_base + (addr & 0x3FFF)] );
                                        case 0xE000:
                                                return( ROM[ MMC_high_base + (addr & 0x3FFF)] );
                                }
                                break;
			case 7:
				switch( addr & 0xE000 )
				{
					case 0x8000:
					case 0xA000:
					case 0xC000:
					case 0xE000:
						return( ROM[ MMC_low_base + (addr & 0x7FFF) ] );
				}
                                break;
                        case 9:
                                return( RAM[ addr ] );
                                break;
			case 11:
				switch( addr & 0xE000 )
				{
					case 0x8000:
					case 0xA000:
					case 0xC000:
					case 0xE000:
						return( ROM[ MMC_low_base + (addr & 0x7FFF) ] );
				}
                                break;
		}
	}
	}
}		
        
inline void Wr6502(register word addr, register byte Value)
{
        int     i;      // Pour le for
	char	tmp[0x1000];
	static int reg0, reg1, reg2, reg3;

	
        switch ( addr & 0xE000 )
        {
        case 0x0000:
        {
            // L je crois qu'il y a eu une petite erreur
            // La ram de 0x0000  0x0800 et rflchi trois fois :

            RAM[ addr & 0x7FF ] = Value;
            break;
        }
        case 0x2000:
            switch (addr)
            {
            case 0x2004:
            {
                // SPRITE IO
                // Easy !:)
                SRAM[ RAM[0x2003] ] = Value;

                RAM[ 0x2003 ]++; // Incrmentation de 1
                break;
            }                        

            case 0x2005:
            {
                if( BGScroll_toggle )
                {
                        // Background Scroll Register
                        // C'est un double write en premier il crite
                        // Le scrolling Horrizontal puis le vertical

                        // Donc Ici le vertical

                        // Pour l'instant on s'en fout

                        if( Value < 240 )
                                PPU_REG_5A = Value;
                        else
                                PPU_REG_5A = 0;
                }
                else
                {
                        // Horizontal
                        PPU_REG_5B = Value;
                }

                BGScroll_toggle =! BGScroll_toggle;
                break;
            }

            // 0x2006 & 0x2007 par MrDavid
                        
            case 0x2006:
            {
                // PPU Memory Adress

              if( PPU_addr_toggle == 1 )
                {
                        // Ecriture des 8 bits infrieur
                        PPU_REG_6 = ( PPU_REG_6 & 0xFF00 ) | ( Value );
                        PPU_addr_toggle = 0;
                }
                else
                {
                        // Ecriture des 8 bits suprieur
                        PPU_REG_6 = ( PPU_REG_6 & 0xFF ) | ( Value << 8 );
                        PPU_addr_toggle = 1;
                }

                FirstRead = 1;

                break;
            }

            case 0x2007:
            {
                // PPU IO Register

                if( RAM[ 0x2002 ] & 0x10 )
                        break;

                Write_PPU( Value );

                break;
            }
            default:
                RAM[ addr ] = Value;
                break;

            }

        case 0x4000:
            // la c'est pareil qu'en 0x2000 sauf qu'on a un peu plus
            // de ports, de 0x4000 - 0x4017.

        switch( addr )
        {
                case 0x4014:
                {
                        // SPRITE DMA

                        // Transfer 256 bytes de mmoires
                        // de l'adresse $100*N
                        // N = est la valeur crit dans le registre                                
                        // dans la RAM des sprites

                        for( i = 0 ; i < 256 ; i++ )
                                SRAM[ i ] = Rd6502( (0x100*Value)+i );
//                        memcpy( &SRAM[ 0x0 ] , &RAM[ 0x100*Value ] , 256 );

                        break;
                }
                case 0x4016:
                {
                        if( RAM[0x4016] == 1 && (Value == 0))
                            Joypad_Read_1 = 0;

                        RAM[0x4016] = Value;    
                        
                        break;
                }
                default:
                {
                        // C'est en fait tous ce qui relatif aux sons

                        RAM[addr] = Value;
                        break;
                }
        }
        case 0x6000:
        {
            // MEMOIRE PILE
            // A ECRIRE DANS LES FUTURES VERSIONS

            // Quoique j'ai une ide sur l'affaire:)

            // David m'a donn le feu vert si je veux l'implant
            // J'avais bien compris:)

	    RAM[ addr ] = Value;
            break;
        }
        default:
        {
        	switch( MMC )
        	{
        		case 0:
        			ROM[ addr - 0x8000 ] = Value;
        			break;
        		case 1:
                                if( Value & 0x80 )
                                {
                                        MMC1_Reg_0_WriteNo = 0;
                                        MMC1_Reg_1_WriteNo = 0;
                                        MMC1_Reg_2_WriteNo = 0;
                                        MMC1_Reg_3_WriteNo = 0;
                                        break;
                                }

                                switch( addr & 0xE000 )
                                {
                                        case 0x8000: // Register 0
//   0    $8000  ???sBKpm  Mapper Control Register #1                 
//         ...                                                        
//        $9FFF             s = Size Select                           
//                                 0 = Select 8K CHR-RAM at $0000     
//                                 1 = Swap 4K at $0000 and $1000     
//                          B = Base Bootup Select                    
//                                 0 = $8000 (Note: This is probably  
//                                 1 = $C000        incorrect!)       
//                          K = Bank Size                             
//                                 0 = 16K                            
//                                 1 = 32K                            
//                          p = Panning/Scrolling Enable/Disable      
//                                 0 = Enabled                        
//                                 1 = Disabled                       
//                          m = Mirror Select                         
//                                 0 = Horizontal Mirroring           
//                                 1 = Vertical Mirroring             
//                                                                    
//                         NOTE: Bit #1, when set to 1, actually just 
//                               mirrors Name Table #0 throughout all 
//                               the other Name Tables.               
                                                if( MMC1_Reg_0_WriteNo < 5 )
                                                {
                                                        if( !MMC1_Reg_0_WriteNo )
                                                                MMC1_Reg_0 = 0;
                                                        MMC1_Reg_0 = MMC1_Reg_0 >> 1;
                                                        MMC1_Reg_0 |= ( Value & 0x01 ) ? 0x10 : 0x00;
                                                        MMC1_Reg_0_WriteNo++;
                                                }
                                                if( MMC1_Reg_0_WriteNo == 5 )
                                                {
                                                        if( ReadBit( MMC1_Reg_0 , 0 ) == 0 && Mirroring != 0 )
                                                                Mirroring = 2; // Horizontal Mirroring
                                                        if( ReadBit( MMC1_Reg_0 , 0 ) == 1 && Mirroring != 0 )
                                                                Mirroring = 1; // Vertical Mirroring

                                                        if( ReadBit( MMC1_Reg_0 , 1 ) == 0 )
                                                                Mirroring = 0;

                                                        MMC_Bank_Size = ReadBit( MMC1_Reg_0 , 2 ); // Bank size set to 16 Ko if 0 or 32 Ko if 1

                                                        MMC_Base_Bootup = ReadBit( MMC1_Reg_0 , 3 ); // 0 : 0x8000
                                                                                                     // 1 : 0xC000
                                                        MMC_Size_Select = ReadBit( MMC1_Reg_0 , 4 ); // 0 : 8 ko at 0x0000
                                                                                                     // 1 : 4 Ko at 0x0000 and 0x1000
                                                        MMC1_Reg_0_WriteNo = 0;
                                                }
                                                break;

                                        case 0xA000: //Register 1
//   1    $A000  ssssssss  CHR-RAM Page Selection Register            
//         ...                                                        
//        $BFFF             Sets the CHR-RAM page at $0000, with the  
//                          size selected via Register #0.            
                                                if( MMC1_Reg_1_WriteNo < 5 )
                                                {
                                                        if( !MMC1_Reg_1_WriteNo )
                                                                MMC1_Reg_1 = 0;

                                                        MMC1_Reg_1 = MMC1_Reg_1 >> 1;
                                                        MMC1_Reg_1 |= ( Value & 0x1) ? 0x10 : 0x0;
                                                        MMC1_Reg_1_WriteNo++;
                                                }
                                                if( MMC1_Reg_1_WriteNo == 5 )
                                                {
                                                        if( CHR_Ram > 0 )
                                                        {
                                                                if( MMC_Size_Select == 0 )
                                                                        memcpy( &VRAM[ 0x0 ] , &VROM[ MMC1_Reg_1 * 0x2000 ] , 0x2000 );
                                                                else
                                                                        memcpy( &VRAM[ 0x0 ] , &VROM[ MMC1_Reg_1 * 0x1000 ] , 0x1000 );
                                                        }
                                                        MMC1_Reg_1_WriteNo = 0;
                                                }
                                                break;
                                        case 0xC000:  // Register 2
//   2    $C000  ssssssss  CHR-RAM 4K Page Selection Register         
//         ...                                                        
//        $DFFF             Sets the 4K CHR-RAM page at $1000, but    
//                          only if 4K CHR-RAM pages are selected via 
//                          Register #0 (otherwise ignored).          
                                                if( MMC1_Reg_2_WriteNo < 5 )
                                                {
                                                        if( !MMC1_Reg_2_WriteNo )
                                                                MMC1_Reg_2 = 0;

                                                        MMC1_Reg_2 = MMC1_Reg_2 >> 1;
                                                        MMC1_Reg_2 |= ( Value & 0x1) ? 0x10 : 0x0;
                                                        MMC1_Reg_2_WriteNo++;
                                                }
                                                if( MMC1_Reg_2_WriteNo == 5 )
                                                {
                                                        if( MMC_Size_Select == 1 )
                                                                memcpy( &VRAM[ 0x1000 ] , &VROM[ MMC1_Reg_2 * 0x1000 ] , 0x1000 );
                                                        MMC1_Reg_2_WriteNo = 0;
                                                }
                                                break;
                                        case 0xE000: // Register 3
//   3    $E000  ssssssss  PRG-ROM 16K Page Selection Register        
//         ...                                                        
//        $FFFF             Sets the 16K ROM page at $8000. The page  
//                          at $C000 is hardwired to the last ROM     
//                          page in the cart. Page 0 starts at $8000. 
                                                if( MMC1_Reg_3_WriteNo < 5 )
                                                {
                                                        if( !MMC1_Reg_3_WriteNo )
                                                                MMC1_Reg_3 = 0;

                                                        MMC1_Reg_3 = MMC1_Reg_3 >> 1;
                                                        MMC1_Reg_3 |= ( Value & 0x1) ? 0x10 : 0x0;
                                                        MMC1_Reg_3_WriteNo++;
                                                }
                                                if( MMC1_Reg_3_WriteNo == 5 )
                                                {
                                                        if( MMC_Base_Bootup == 1 )
                                                        {
                                                                MMC_low_base = MMC1_Reg_3 * 0x4000;
                                                                MMC_high_base = MMC1_High;
                                                        }
                                                        else
                                                        {
                                                                MMC_low_base = 0;
                                                                MMC_high_base = MMC1_Reg_3 * 0x4000;
                                                        }
                                                        MMC1_Reg_3_WriteNo = 0;
                                                }
                                                break;
                                }
                                break;
                        case 2: 
                                MMC_low_base = Value * 16384;
        			break;
        		case 3:
        			MMC_chr = Value * 8192;
        			memcpy( &VRAM[ 0 ], &VROM[ MMC_chr ], 0x2000 );
        			break;
        		case 4:
                        {
                                   static int cmd = 0;
                                   static int chr = 0;
                                   static int prg = 0;
                                   static int irq;

                                   switch( addr )
                                   {
                                           case 0x8000:
                                                   cmd = Value & 0x07;
                                                   if( Value & 0x80 )
                                                           chr = 0x1000;
                                                   else
                                                           chr = 0x0000;

                                                 if( Value & 0x40 )
                                                 {
                                                        MMC_low_base = MMC_high_base;
                                                        prg = 0xA000;
                                                 }
                                                 else
                                                 {
                                                        MMC4_hmid_base = MMC_high_base;
                                                        prg = 0x8000;
                                                 }
                                                 break;
                                        case 0x8001:
                                                switch(cmd)
                                                {
                                                        case 0:
                                                                Value &= 0xFE;
                                                                memcpy(&VRAM[chr ^ 0],&VROM[Value*0x400], 0x800);
                                                                break;
                                                        case 1:
                                                                memcpy(&VRAM[chr ^ 0x0800], &VROM[Value*0x400],0x800);
                                                                break;
                                                        case 2:
                                                                memcpy(&VRAM[chr ^ 0x1000], &VROM[Value*0x400],0x400);
                                                                break;
                                                        case 3:
                                                                memcpy(&VRAM[chr ^ 0x1400], &VROM[Value*0x400],0x400);
                                                                break;
                                                        case 4:
                                                                memcpy(&VRAM[chr ^ 0x1800], &VROM[Value*0x400],0x400);
                                                                break;
                                                        case 5:
                                                                memcpy(&VRAM[chr ^ 0x1C00], &VROM[Value*0x400],0x400);
                                                                break;
                                                        case 6:
                                                                MMC4_mid_base = MMC_low_base = 0x2000 * (Value & 0x7F);
                                                                break;
                                                        case 7:
                                                                break;
                                                }
                                                cmd = 8;
                                                break;
		case 0xA000:
                	Mirroring = 0x02 >> (Value & 0x01);
                        break;
                case 0xC000:
                        if(Value == 0)
 	                       MMC4_IRQ = -1;
                        else
                               MMC4_IRQ = Value;
                        break;
                case 0xC001:
	                irq = Value;
                        break;
                case 0xE000:
                        if(irq == 0)
          	              MMC4_IRQ = -1;
                        else
                              MMC4_IRQ = irq;
                        break;
                case 0xE001:
                        MMC4_DOIRQ = 1;
                        break;
	}
	break;
   }
		       				break;
        		case 7:
                                MMC7_Write( Value , addr );
                                break;
                        case 9:
                                MMC9_Write( Value , addr );
                                break;
                        case 11:
        			MMC_chr = ( Value & 0xF0 ) * 8192;
        			MMC_low_base = ( Value & 0x0F ) * 32768;
        			memcpy( VRAM , &VROM[ MMC_chr ] , 0x2000 );
        			break;
        	}
        }
	}
}

byte Loop6502(register M6502 *R)
{
        int ret = (ReadBit( RAM[ 0x2000 ] , 7 ) == 1) ? INT_NMI : INT_NONE;

        if( CurrentFrame >= FrameRate )
        {
                if( ReadBit( RAM[ 0x2001 ] , 3 ) == 1 )                
                {
                        Refresh_Screen();
                        RAM[ 0x2002 ] |= 0x80;
                        if(MMC == 4 && MMC4_DOIRQ)
                        {
                                if(MMC4_IRQ <= 232)
                                {
                                        ret = INT_IRQ;
                                        MMC4_DOIRQ = 0;
                                        MMC4_IRQ = -1;
                                }
                                else
                                        MMC4_IRQ -= 232;
                        }
                }
                CurrentFrame = 1;
        }
        else
                CurrentFrame++;

        CheckKb();

        RAM[ 0x2002 ] |= 0x80;
        RAM[ 0x4016 ] &= 0xFD;

        if( ReadBit( RAM[ 0x2000 ] , 7 ) == 1 )
                return( INT_NMI );
        if( ReadBit( RAM[ 0x2000 ] , 6 ) == 1 && ReadBit( RAM[ 0x2001 ] , 4 ) == 1 )
                return( INT_NMI );                

        return( ret );
}

#include        "mmc.h"

