/*
        MMC Write enabled
*/

int     MMC7_Write( byte Value , word addr )
{
        if(ReadBit( addr, 5 ) == 0)
                MMC_Table = 0x2000;
        else
                MMC_Table = 0x2400;

        Value &= 0x0F;
                        
        MMC_low_base = Value * 32768;
}       

int     MMC9_Write( word addr , byte Value )
{
// $A000     W     dddddddd  PRG-ROM 8K Page Select Register             
//  ...                                                                  
// $AFFF                        d = 8K PRG-ROM Select                    
//                                   Selects 8K PRG-ROM bank at $8000.   
//                                                                       
// $B000     W     dddddddd  CHR-RAM 4K Page Select Register #1          
// $C000                                                                 
//                              d = 4K CHR-RAM Select                    
//                                   Selects 4K CHR-RAM bank at VRAM     
//                                   address $0000.                      
//                                                                       
// $D000     W     dddddddd  CHR-RAM 4K Page Select Register #2          
// $E000                                                                 
//                              d = 4K CHR-RAM Select                    
//                                   Selects 4K CHR-RAM bank at VRAM     
//                                   address $1000.                      
//
//  NOTE: The CHR-RAM 4K Page Select Register seem to work in congruency;
//by this I mean, when data is written to $B000, $D000 will function, but
//$E000 will not (and therefore, the same rules apply to $C000/$E000 where
//$D000 will not work).
                                if( addr >= 0xA000 && addr <= 0xAFFF )
                                {
                                        memcpy( &RAM[ 0x8000 ] , &ROM[ Value*0x2000 ] , 0x2000 );
                                        return;
                                }
                                switch( addr )
                                {
                                        case    0xB000:
                                                memcpy( &VRAM[ 0x0 ] , &VROM[ Value * 0x1000 ] , 0x1000 );
                                                return;
                                        case    0xC000:
                                                memcpy( &VRAM[ 0x0 ] , &VROM[ Value * 0x1000 ] , 0x1000 );      
                                                return;
                                        case    0xD000:
                                                memcpy( &VRAM[ 0x1000 ] , &VROM[ Value * 0x1000 ] , 0x1000 );
                                                return;
                                        case    0xE000:
                                                memcpy( &VRAM[ 0x1000 ] , &VROM[ Value * 0x1000 ] , 0x1000 );
                                                return;
                                        case    0xF000:
                                                if( Value == 0 )
                                                        Mirroring = 2; // Horizontal Mirroring
                                                else
                                                        Mirroring = 1;
                                                return;
                                }
}
